accounts/urls.py
from django.contrib import admin
from django.urls import include, path, re_path
from .views import *
import article.views as article
urlpatterns = [
    path('',base_view,name='base'),
    path('login',login_view,name='login'),
    path('home',home_view,name='home'),
    path('signup',signup_view,name='signup'),
    path('logout',logout_view,name='logout'),
    path('base',basetemp_view,name='basetemp'),
    path('registrasi',registrasi_view,name='registrasi'),
    path('registrasi/psikolog',psikolog_view,name='psikolog'),
]

appdemo/urls.py
from django.urls import path
from .views import index
urlpatterns = [
    path('', index, name='index'),
]

home/home/urls.py
from django.contrib import admin
from django.urls import path

urlpatterns = [
    path('admin/', admin.site.urls),
]

tkpbp/urls.py
from django.urls import include, path, re_path
from django.contrib import admin
from article.views import index as index_article
import article.urls as article
import accounts.urls as accounts
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('',include(accounts)),
    path('artikel/', include(('article.urls','article'), namespace='article')),
    # re_path(r'^$', index_article, name='index'),


]
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/models.py
from django.contrib.auth.base_user import BaseUserManager
from django.db import models
from django.contrib.auth.models import AbstractBaseUser, PermissionsMixin
# Create your models here.

class AccountManager(BaseUserManager):
    def create_user(self, email,name,is_counselor = False, password=None, **other_fields):
        """
        Creates and saves a User with the given email and password.
        """

        if not email:
            raise ValueError('Users must have an email address')

        user = self.model(
            email=self.normalize_email(email),
            name = name,
            is_counselor = is_counselor,
            **other_fields
        )

        user.set_password(password)
        user.save()
        return user



    def create_superuser(self, email,name,is_counselor = False, password=None, **other_fields):
        """
        Creates and saves a superuser with the given email and password.
        """
        other_fields.setdefault('is_active',True)
        other_fields.setdefault('is_staff',True)
        other_fields.setdefault('is_superuser',True)
        if other_fields.get('is_active') is not True: 
            raise ValueError('error1')
        if other_fields.get('is_staff') is not True:
            raise ValueError('error2')
        if other_fields.get('is_superuser') is not True:
            raise ValueError('error3')
        return self.create_user(email,name = name,password=password,**other_fields)

class Account(AbstractBaseUser,PermissionsMixin):
    email = models.EmailField(verbose_name = 'email address',max_length=255,unique=True)
    name = models.CharField(max_length=255)
    is_active = models.BooleanField(default=True)
    is_counselor = models.BooleanField(default=False)
    is_staff = models.BooleanField(default=False)
    is_superuser = models.BooleanField(default=False)
    
    objects = AccountManager()

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['name']

    def __str__(self):
        return self.name

accounts/forms.py
from django import forms
from django.contrib.auth import get_user_model    
from django.contrib.auth.forms import AuthenticationForm, UsernameField,UserCreationForm


class MyAuthenticationForm(AuthenticationForm):
    username = UsernameField(
        label='email',
        widget=forms.TextInput(attrs={'autofocus': True,'placeholder': 'email'})
    )
    password = forms.CharField(
        label='password',
        strip=False,
        widget=forms.PasswordInput(attrs={'autocomplete': 'current-password','placeholder' : 'password'}),
    )

class MyUserForm(UserCreationForm):
    
	class Meta:
		model = get_user_model()
		fields = ("name","email", "password1", "password2")


	def save(self, commit=True):
		user = super(MyUserForm, self).save(commit=False)
		user.email = self.cleaned_data['email']
		if commit:
			user.save()
		return user

accounts/views.py
from django.http.response import HttpResponseRedirect
from django.shortcuts import redirect, render
from django.contrib.auth.forms import UserCreationForm,AuthenticationForm
from django.contrib.auth import get_user, login, logout
from accounts.forms import *
from django.contrib.auth.views import LoginView


# Create your views here.
def base_view(request):
    if request.user.is_authenticated:
        return HttpResponseRedirect('home')
    else:
        return HttpResponseRedirect('login')

def signup_view(request):
    context = {}
    if request.method == 'POST':
        form = MyUserForm(data =request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('/')
        else:
            context['registration_form'] = form
        # else:
        #     return redirect('halo.html')    
    form = MyUserForm()
    context['form'] = form
    return render(request,'signup.html',context)


def login_view(request):
    context = {}
    if request.method == 'POST':
        form = AuthenticationForm(data=request.POST)
        if form.is_valid():
            user = form.get_user()
            login(request,user)
            return HttpResponseRedirect('artikel')

    else:
        form = AuthenticationForm()
    
    form.fields['username'].widget.attrs.update({'placeholder': 'Email','class':'form-control'})
    form.fields['password'].widget.attrs.update({'placeholder': 'Password','class':'form-control'})
    context['form'] = form
    context['nbar'] = 'login'
    return render(request,'login.html',context)

def home_view(request):
    if request.user.is_authenticated:
        return render(request,'halo.html')
    else:
        return render(request,'bisagila.html')

def logout_view(request):
    logout(request)
    return HttpResponseRedirect('login')

def registrasi_view(request):
    return render(request,'registrasi.html', {'nbar' : 'Registrasi'})

def psikolog_view(request):
    if request.user.is_authenticated and request.user.is_counselor:
        return render(request,'psikolog.html', {'nbar' : 'Registrasi'})
    return render(request,'bisagila.html')
# Untuk liat base
def basetemp_view(request):
    return render(request,'base.html',{'nbar' : 'base'})


    

accounts/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
        
        <!-- Option 1: Bootstrap Bundle with Popper -->
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
        
        <!-- Setup Google Fonts -->
        <link rel="preconnect" href="https://fonts.googleapis.com">
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        {% block css %}
            <!-- Imported Google Fonts -->
            <link href="https://fonts.googleapis.com/css2?family=Roboto&display=swap" rel="stylesheet">
            <link href="https://fonts.googleapis.com/css2?family=Inter:wght@700&display=swap" rel="stylesheet">
            <!-- Style CSS -->
            <link rel="stylesheet" href="{% static '../static/css/base.css' %}">
        {% endblock %}
    </head>
    <body>
        {% block body %}
            <nav class="navbar-nav navbar-dark navbar-expand-lg  mynav">
                <button class="navbar-toggler custom-toggler" type="button" data-toggle="collapse" data-target="#navbar1" aria-controls="navbar1" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>             
                </button>
                <div class="collapse navbar-collapse " id="navbar1">
                    <ul class="navbar-nav me-auto ">
                        <span class="navbar-brand mb-0 h1 logo">Ruang Singgah<span class="yellow">.</span></span>
                        <li class="nav-item">
                            <a href="#" class="nav-link {% if nbar == 'Konsultasi' %} active {% endif %}">Konsultasi</a>
                        </li>
                        <li class="nav-item">
                            <a href="{% url 'article:index' %}" class="nav-link {% if nbar == 'Artikel' %} active {% endif %}">Artikel</a>
                        </li>
                        <li class="nav-item">
                            <a href="#" class="nav-link {% if nbar == 'Quiz' %} active {% endif %}">Quiz</a>
                        </li>
                        <li class="nav-item">
                            <a href="#" class="nav-link {% if nbar == 'Diskusi' %} active {% endif %}">Diskusi</a>
                        </li>
                        <li class="nav-item">
                            <a href="#" class="nav-link {% if nbar == 'Donasi' %} active {% endif %}">Donasi</a>
                        </li>
                        

                    </ul>
                    <ul class="navbar-nav rightnav">
                        <li class="nav-item">
                            <a href="{% url 'registrasi' %}" class="nav-link{% if nbar == 'Registrasi' %} active {% endif %}">Registrasi</a>
                        </li>
                        <li class="nav-item">
                            {% if request.user.is_authenticated %}
                            <a href="#" class="nav-link">Halo, {{request.user.name}}!</a>
                            {% else %}
                               <a href="{% url 'login' %}" class="nav-link{% if nbar == 'login' %} active {% endif %}   ">Login</a>
                            {% endif %}
                        </li>
                    </ul>
                </div>
            </nav>          
            <script src="https://code.jquery.com/jquery-3.5.1.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script>
        <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    </body>
    {% endblock %}
    {% block footer %}
    <footer class="row myfooter">
        <p class="text-center footerlogo">Ruang Singgah<span class="yellow">.</span></p>
        <p class="text-center footerdesc">Ruang untuk bercerita</p>
        <p class="text-center estimated">Est.2021 Kelompok D04</p>

    </footer>
{% endblock %}
</html>

accounts/templates/bisagila.html
{% extends 'base.html' %}
{% load static %}
    {% block body %}
        {{block.super}}
        <h1>ANDA SUDAH GILA?</h1><br>
        <h2>Anda belum loginnn </h2>
    {% endblock %}

accounts/templates/halo.html
{% extends 'base.html' %}
{% load static %}
    {% block body %}
        {{block.super}}
        <h1>HALO!!</h1>
        <form action="{% url 'logout' %}" method= "post">
            {% csrf_token %}
            <button type="submit">Logout</button>
        </form>
    {% endblock %}

accounts/templates/login.html
{% extends 'base.html' %}
{% load static %}
    {% block css %}
    {{block.super}}
    <link rel="stylesheet" href="{% static '../static/css/login.css' %}">
    <link href="https://fonts.googleapis.com/css2?family=Russo+One&display=swap" rel="stylesheet">
    {% endblock %}
    {% block body %}
        {{block.super}}
        <section class="loginform">
            <div class="container-fluid">
                <div class="row">
                   
                    <div class="col-sm-12 col-lg-5 offset-1">
                        <p class="h1">Ruang <br> Singgah<span class="yellow">.</span></p>
                        <div class="col-8">
                            <div class="form-group">
                                <form action="" method="POST">
                                    <div class="d-grid gap-2">
                                        {% csrf_token %}
                                        {{form.username}}
                                        <br>
                                        {{form.password}}
                                        <br>
                                        <input class="btn btn-lg btn-login" type="submit" value="LOGIN">
                                        <p class="text-center notsignedup">Belum punya akun? daftar <a href="{% url 'signup' %}">di sini</a> </p>
                                    </div>
    
                                </form>
                            </div>
                        </div>
                        
                    </div>
                    <div class="col-sm-12 col-lg-6 mycol">
                        <div class="image-banner">
                            <img src="{% static '../static/images/loginart.png' %}" class="img-fluid" alt="Ilustrasi"> 
                        </div>
                    </div>
                </div>
                
                
            </div>

            
            
        </section>
        <!-- {{ form.username }}
        {{ form.password }} -->
        {% endblock %}
   

    
</html>

accounts/templates/loginbackup.html
{% load static %}
<!DOCTYPE html>
<html>
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
        
        <!-- Option 1: Bootstrap Bundle with Popper -->
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
        
        <!-- Google Fonts -->
        <link rel="preconnect" href="https://fonts.googleapis.com">
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link href="https://fonts.googleapis.com/css2?family=Russo+One&display=swap" rel="stylesheet">
        <link href="https://fonts.googleapis.com/css2?family=Roboto&display=swap" rel="stylesheet">
        <!-- Style CSS -->
        <link rel="stylesheet" href="{% static '../static/css/main.css' %}">
    </head>
    <body>
        <section class="loginform">
            <div class="container-fluid">
                <div class="row">
                   
                    <div class="col-5 offset-1">
                        <p class="h1">Ruang <br> Singgah<span class="yellow">.</span></p>
                        <div class="col-8">
                            <div class="form-group">
                                <form action="" method="POST">
                                    <div class="d-grid gap-2">
                                        {% csrf_token %}
                                        {{form.username}}
                                        <br>
                                        {{form.password}}
                                        <br>
                                        <input class="btn btn-lg btn-login" type="submit" value="LOGIN">
                                        <p class="text-center notsignedup">Belum punya akun? daftar <a href="{% url 'signup' %}">di sini</a> </p>
                                    </div>
    
                                </form>
                            </div>
                        </div>
                        
                    </div>
                    <div class="col-6">
                        <div class="image-banner">
                            <img src="{% static '../static/images/loginart.png' %}" class="img-fluid" width="100%" alt="Ilustrasi"> 
                        </div>
                    </div>
                </div>
                
                
            </div>

            
            
        </section>
        <!-- {{ form.username }}
        {{ form.password }} -->

   
    </body>
    
</html>

accounts/templates/psikolog.html
{% extends 'base.html' %}
{% load static %}
{% block body %}
    {{block.super}}
    <h1>Halo psikolog :D</h1>
{% endblock %}

accounts/templates/registrasi.html
{% extends 'base.html' %}
{% load static %}
{% block css %}
    {{block.super}}
    <link rel="stylesheet" href="{% static '../static/css/registrasi.css' %}">
{% endblock %}
{% block body %}
    {{block.super}}
    <div class="row cardgroup">
        <p class="h1 text-center judul">Registrasi</p>
        <div class="col-sm-12 col-lg-6 registercard">
            <div class="card h-100 mx-auto mhscard">
                
                <div class="card-header text-center">
                    Mahasiswa
                </div>
                <img src="{% static '../static/images/mhs-ilustrasi.png' %}" alt="Ilustrasi Konseling Mahasiswa" class="card-img-center mx-auto">
                <div class="card-body">
                    <p class="card-text text-center mt-5 description">
                        Dapatkan akun untuk membuat jadwal konsultasi dengan psikolog 
                    </p>
                    <a href="{% url 'signup' %}" class="stretched-link"></a>
                    <!-- <a href="{% url 'signup' %}" class="card-link">Di sini</a> -->
                </div>
            </div>
            
        </div>
        <div class="col-sm-12 col-lg-6 registercard">
            <div class="card h-100 mx-auto psikologcard">
                <div class="card-header text-center">
                    Psikolog
                </div>
                <img src="{% static '../static/images/psiko-ilustrasi.png' %}" alt="Ilustrasi Psikolog" class="card-img-center mx-auto">
                <div class="card-body">
                    <a href="{% url 'psikolog' %}" class="stretched-link"></a>
                    <p class="card-text text-center mt-5 description">
                        Yuk daftar menjadi konselor RuangSInggah :D
                    </p>
                </div>
            </div>
        </div>
    </div>
    
{% endblock %}

accounts/templates/signup.html
<h1>Sign Up</h1>
<form action="" method="post">
    {% csrf_token %}
    {{form}}
    {% for field in registration_form %}
        {% for error in field.errors %}
        <p style="color: red">{{error}}</p>
        <p>{{field.name }}</p>
        {% endfor %}
    {% endfor %}
    <input type="submit" value="signup">
</form>